#if defined(__STDC__)
#define v_new(TYPE, NEW_OBJ) \
                new_vector(NEW_OBJ, TYPE##_hatch_size)
#define v_is(TYPE, OBJ) \
                vector(OBJ, TYPE##_hatch_size)
#define v_gread(TYPE, ATTR, OBJ, VAL) \
                vector_element(OBJ, TYPE##_hatch_##ATTR, VAL)
#define v_read(TYPE, ATTR, OLD_OBJ, NEW_OBJ, VAL) \
                vector_element(OLD_OBJ, TYPE##_hatch_##ATTR, VAL, NEW_OBJ)
#define v_get(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL, OLD_VAL) \
                set_vector_element(OLD_OBJ, TYPE##_hatch_##ATTR, \
				   OLD_VAL, NEW_VAL, NEW_OBJ)
#define v_set(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL) \
                set_vector_element(OLD_OBJ, TYPE##_hatch_##ATTR, \
				   _, NEW_VAL, NEW_OBJ)

#define tagged_new(TYPE, OBJ) \
                new_vector(_Obj, TYPE##_hatch_size), \
                set_vector_element(_Obj, 0, _, \
				   TYPE##_hatch_tag, OBJ)
#define tagged_is(TYPE, OBJ) \
                vector(OBJ, TYPE##_hatch_size), \
                vector_element(OBJ, 0, TYPE##_hatch_tag)
#define tagged_gread(TYPE, ATTR, OBJ, VAL) \
                vector_element(OBJ, TYPE##_hatch_##ATTR, VAL), \
                vector_element(OBJ, 0, TYPE##_hatch_tag)
#define tagged_read(TYPE, ATTR, OLD_OBJ, NEW_OBJ, VAL) \
                v_read(TYPE, ATTR, OLD_OBJ, NEW_OBJ, VAL)
#define tagged_get(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL, OLD_VAL) \
                v_get(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL, OLD_VAL)
#define tagged_set(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL) \
                v_set(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL)
#else
#define v_new(TYPE, NEW_OBJ) new_vector(NEW_OBJ,TYPE/**/_hatch_size)
#define v_is(TYPE, OBJ) vector(OBJ,TYPE/**/_hatch_size)
#define v_gread(TYPE, ATTR, OBJ, VAL) \
                vector_element(OBJ,TYPE/**/_hatch_/**/ATTR,VAL)
#define v_read(TYPE, ATTR, OLD_OBJ, NEW_OBJ, VAL) \
                vector_element(OLD_OBJ,TYPE/**/_hatch_/**/ATTR,VAL,NEW_OBJ)
#define v_get(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL, OLD_VAL) \
                set_vector_element(OLD_OBJ,TYPE/**/_hatch_/**/ATTR,\
				   OLD_VAL,NEW_VAL,NEW_OBJ)
#define v_set(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL) \
                set_vector_element(OLD_OBJ,TYPE/**/_hatch_/**/ATTR,\
				   _,NEW_VAL,NEW_OBJ)

#define tagged_new(TYPE, OBJ) \
                new_vector(_Obj,TYPE/**/_hatch_size), \
                set_vector_element(_Obj,0,_,TYPE/**/_hatch_tag,OBJ)
#define tagged_is(TYPE, OBJ) \
                vector(OBJ,TYPE/**/_hatch_size), \
                vector_element(OBJ,0,TYPE/**/_hatch_tag)
#define tagged_gread(TYPE, ATTR, OBJ, VAL) \
                vector_element(OBJ,TYPE/**/_hatch_/**/ATTR,VAL), \
                vector_element(OBJ,0,TYPE/**/_hatch_tag)
#define tagged_read(TYPE, ATTR, OLD_OBJ, NEW_OBJ, VAL) \
                v_read(TYPE,ATTR,OLD_OBJ,NEW_OBJ,VAL)
#define tagged_get(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL, OLD_VAL) \
                v_get(TYPE,ATTR,OLD_OBJ,NEW_OBJ,NEW_VAL,OLD_VAL)
#define tagged_set(TYPE, ATTR, OLD_OBJ, NEW_OBJ, NEW_VAL) \
                v_set(TYPE,ATTR,OLD_OBJ,NEW_OBJ,NEW_VAL)
#endif
